diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.32/src/network/bindings/modulegen__gcc_LP64.py ns-3.33/src/network/bindings/modulegen__gcc_LP64.py
--- ns-3.32/src/network/bindings/modulegen__gcc_LP64.py	2020-10-06 15:35:43.000000000 -0700
+++ ns-3.33/src/network/bindings/modulegen__gcc_LP64.py	2021-01-09 10:19:22.000000000 -0800
@@ -4849,6 +4858,11 @@
                    'int64_t', 
                    [], 
                    is_const=True)
+    ## int64x64-128.h (module 'core'): int64_t ns3::int64x64_t::GetInt() const [member function]
+    cls.add_method('GetInt', 
+                   'int64_t', 
+                   [], 
+                   is_const=True)
     ## int64x64-128.h (module 'core'): uint64_t ns3::int64x64_t::GetLow() const [member function]
     cls.add_method('GetLow', 
                    'uint64_t', 
@@ -4863,6 +4877,11 @@
     cls.add_method('MulByInvert', 
                    'void', 
                    [param('ns3::int64x64_t const &', 'o')])
+    ## int64x64-128.h (module 'core'): int64_t ns3::int64x64_t::Round() const [member function]
+    cls.add_method('Round', 
+                   'int64_t', 
+                   [], 
+                   is_const=True)
     ## int64x64-128.h (module 'core'): ns3::int64x64_t::implementation [variable]
     cls.add_static_attribute('implementation', 'ns3::int64x64_t::impl_type const', is_const=True)
     return
@@ -5096,12 +5115,12 @@
     cls.add_method('GetObject', 
                    'ns3::Ptr< ns3::Object >', 
                    [], 
-                   is_const=True, template_parameters=['ns3::Object'], custom_template_method_name='GetObject')
+                   custom_template_method_name='GetObject', is_const=True, template_parameters=['ns3::Object'])
     ## object.h (module 'core'): ns3::Ptr<ns3::Object> ns3::Object::GetObject(ns3::TypeId tid) const [member function]
     cls.add_method('GetObject', 
                    'ns3::Ptr< ns3::Object >', 
                    [param('ns3::TypeId', 'tid')], 
-                   is_const=True, template_parameters=['ns3::Object'], custom_template_method_name='GetObject')
+                   custom_template_method_name='GetObject', is_const=True, template_parameters=['ns3::Object'])
     ## object.h (module 'core'): static ns3::TypeId ns3::Object::GetTypeId() [member function]
     cls.add_method('GetTypeId', 
                    'ns3::TypeId', 
@@ -5515,10 +5534,18 @@
     cls.add_method('SetFrameFlags', 
                    'void', 
                    [param('uint8_t', 'flags')])
-    ## radiotap-header.h (module 'network'): void ns3::RadiotapHeader::SetHeFields(uint16_t data1, uint16_t data2, uint16_t data3, uint16_t data5) [member function]
+    ## radiotap-header.h (module 'network'): void ns3::RadiotapHeader::SetHeFields(uint16_t data1, uint16_t data2, uint16_t data3, uint16_t data4, uint16_t data5, uint16_t data6) [member function]
     cls.add_method('SetHeFields', 
                    'void', 
-                   [param('uint16_t', 'data1'), param('uint16_t', 'data2'), param('uint16_t', 'data3'), param('uint16_t', 'data5')])
+                   [param('uint16_t', 'data1'), param('uint16_t', 'data2'), param('uint16_t', 'data3'), param('uint16_t', 'data4'), param('uint16_t', 'data5'), param('uint16_t', 'data6')])
+    ## radiotap-header.h (module 'network'): void ns3::RadiotapHeader::SetHeMuFields(uint16_t flags1, uint16_t flags2, std::array<unsigned char, 4> const & ruChannel1, std::array<unsigned char, 4> const & ruChannel2) [member function]
+    cls.add_method('SetHeMuFields', 
+                   'void', 
+                   [param('uint16_t', 'flags1'), param('uint16_t', 'flags2'), param('std::array< unsigned char, 4 > const &', 'ruChannel1'), param('std::array< unsigned char, 4 > const &', 'ruChannel2')])
+    ## radiotap-header.h (module 'network'): void ns3::RadiotapHeader::SetHeMuPerUserFields(uint16_t per_user_1, uint16_t per_user_2, uint8_t perUserPosition, uint8_t perUserKnown) [member function]
+    cls.add_method('SetHeMuPerUserFields', 
+                   'void', 
+                   [param('uint16_t', 'per_user_1'), param('uint16_t', 'per_user_2'), param('uint8_t', 'perUserPosition'), param('uint8_t', 'perUserKnown')])
     ## radiotap-header.h (module 'network'): void ns3::RadiotapHeader::SetMcsFields(uint8_t known, uint8_t flags, uint8_t mcs) [member function]
     cls.add_method('SetMcsFields', 
                    'void', 
@@ -6909,57 +6936,57 @@
     cls.add_method('GetCppTypeid', 
                    'std::string', 
                    [], 
-                   template_parameters=['ns3::ObjectBase*'], is_static=True, visibility='protected')
+                   is_static=True, template_parameters=['ns3::ObjectBase*'], visibility='protected')
     ## callback.h (module 'core'): static std::string ns3::CallbackImplBase::GetCppTypeid() [member function]
     cls.add_method('GetCppTypeid', 
                    'std::string', 
                    [], 
-                   template_parameters=['void'], is_static=True, visibility='protected')
+                   is_static=True, template_parameters=['void'], visibility='protected')
     ## callback.h (module 'core'): static std::string ns3::CallbackImplBase::GetCppTypeid() [member function]
     cls.add_method('GetCppTypeid', 
                    'std::string', 
                    [], 
-                   template_parameters=['unsigned int'], is_static=True, visibility='protected')
+                   is_static=True, template_parameters=['unsigned int'], visibility='protected')
     ## callback.h (module 'core'): static std::string ns3::CallbackImplBase::GetCppTypeid() [member function]
     cls.add_method('GetCppTypeid', 
                    'std::string', 
                    [], 
-                   template_parameters=['ns3::Ptr<ns3::NetDevice> '], is_static=True, visibility='protected')
+                   is_static=True, template_parameters=['ns3::Ptr<ns3::NetDevice> '], visibility='protected')
     ## callback.h (module 'core'): static std::string ns3::CallbackImplBase::GetCppTypeid() [member function]
     cls.add_method('GetCppTypeid', 
                    'std::string', 
                    [], 
-                   template_parameters=['ns3::Ptr<ns3::Packet const> '], is_static=True, visibility='protected')
+                   is_static=True, template_parameters=['ns3::Ptr<ns3::Packet const> '], visibility='protected')
     ## callback.h (module 'core'): static std::string ns3::CallbackImplBase::GetCppTypeid() [member function]
     cls.add_method('GetCppTypeid', 
                    'std::string', 
                    [], 
-                   template_parameters=['unsigned short'], is_static=True, visibility='protected')
+                   is_static=True, template_parameters=['unsigned short'], visibility='protected')
     ## callback.h (module 'core'): static std::string ns3::CallbackImplBase::GetCppTypeid() [member function]
     cls.add_method('GetCppTypeid', 
                    'std::string', 
                    [], 
-                   template_parameters=['ns3::Address const&'], is_static=True, visibility='protected')
+                   is_static=True, template_parameters=['ns3::Address const&'], visibility='protected')
     ## callback.h (module 'core'): static std::string ns3::CallbackImplBase::GetCppTypeid() [member function]
     cls.add_method('GetCppTypeid', 
                    'std::string', 
                    [], 
-                   template_parameters=['ns3::NetDevice::PacketType'], is_static=True, visibility='protected')
+                   is_static=True, template_parameters=['ns3::NetDevice::PacketType'], visibility='protected')
     ## callback.h (module 'core'): static std::string ns3::CallbackImplBase::GetCppTypeid() [member function]
     cls.add_method('GetCppTypeid', 
                    'std::string', 
                    [], 
-                   template_parameters=['ns3::Ptr<ns3::QueueDiscItem const> '], is_static=True, visibility='protected')
+                   is_static=True, template_parameters=['ns3::Ptr<ns3::QueueDiscItem const> '], visibility='protected')
     ## callback.h (module 'core'): static std::string ns3::CallbackImplBase::GetCppTypeid() [member function]
     cls.add_method('GetCppTypeid', 
                    'std::string', 
                    [], 
-                   template_parameters=['ns3::Ptr<ns3::Socket> '], is_static=True, visibility='protected')
+                   is_static=True, template_parameters=['ns3::Ptr<ns3::Socket> '], visibility='protected')
     ## callback.h (module 'core'): static std::string ns3::CallbackImplBase::GetCppTypeid() [member function]
     cls.add_method('GetCppTypeid', 
                    'std::string', 
                    [], 
-                   template_parameters=['bool'], is_static=True, visibility='protected')
+                   is_static=True, template_parameters=['bool'], visibility='protected')
     return
 
 def register_Ns3CallbackValue_methods(root_module, cls):
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.32/src/network/test/packet-test-suite.cc ns-3.33/src/network/test/packet-test-suite.cc
--- ns-3.32/src/network/test/packet-test-suite.cc	2020-10-06 15:35:43.000000000 -0700
+++ ns-3.33/src/network/test/packet-test-suite.cc	2021-01-09 10:19:22.000000000 -0800
@@ -716,6 +716,8 @@
     p1->Serialize (buffer, serializedSize);
 
     Ptr<Packet> p2 = Create<Packet> (buffer, serializedSize, true);
+    
+    delete [] buffer;
 
     ATestTag<10> a2;
     ATestTag<11> b2;
@@ -748,7 +750,9 @@
     p1->Serialize (buffer, serializedSize);
 
     Ptr<Packet> p2 = Create<Packet> (buffer, serializedSize, true);
-
+    
+    delete [] buffer;
+    
     CHECK_DATA (p2, 3, E_DATA (10, 0, 1000, 65), E_DATA (11, 0, 1000, 66), E_DATA (12, 0, 1000, 67));
   }
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.32/src/network/utils/dynamic-queue-limits.h ns-3.33/src/network/utils/dynamic-queue-limits.h
--- ns-3.32/src/network/utils/dynamic-queue-limits.h	2020-10-06 15:35:43.000000000 -0700
+++ ns-3.33/src/network/utils/dynamic-queue-limits.h	2021-01-09 10:19:22.000000000 -0800
@@ -87,25 +87,25 @@
   int32_t Posdiff (int32_t a, int32_t b);
 
   // Fields accessed in enqueue path
-  uint32_t m_numQueued;                 //!< Total ever queued
-  uint32_t m_adjLimit;                  //!< limit + num_completed
-  uint32_t m_lastObjCnt;                //!< Count at last queuing
+  uint32_t m_numQueued {0};                 //!< Total ever queued
+  uint32_t m_adjLimit {0};                  //!< limit + num_completed
+  uint32_t m_lastObjCnt {0};                //!< Count at last queuing
 
   // Fields accessed only by completion path
-  TracedValue<uint32_t> m_limit;        //!< Current limit
-  uint32_t m_numCompleted;              //!< Total ever completed
+  TracedValue<uint32_t> m_limit;            //!< Current limit
+  uint32_t m_numCompleted {0};              //!< Total ever completed
 
-  uint32_t m_prevOvlimit;               //!< Previous over limit
-  uint32_t m_prevNumQueued;             //!< Previous queue total
-  uint32_t m_prevLastObjCnt;            //!< Previous queuing cnt
+  uint32_t m_prevOvlimit {0};               //!< Previous over limit
+  uint32_t m_prevNumQueued {0};             //!< Previous queue total
+  uint32_t m_prevLastObjCnt {0};            //!< Previous queuing cnt
 
-  uint32_t m_lowestSlack;               //!< Lowest slack found
-  Time m_slackStartTime;                //!< Time slacks seen
+  uint32_t m_lowestSlack {std::numeric_limits<uint32_t>::max ()};  //!< Lowest slack found
+  Time m_slackStartTime {Seconds (0)};      //!< Time slacks seen
 
   // Configuration
-  uint32_t m_maxLimit;                  //!< Max limit
-  uint32_t m_minLimit;                  //!< Minimum limit
-  Time m_slackHoldTime;                 //!< Time to measure slack
+  uint32_t m_maxLimit;                      //!< Max limit
+  uint32_t m_minLimit;                      //!< Minimum limit
+  Time m_slackHoldTime;                     //!< Time to measure slack
 };
 
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.32/src/network/utils/radiotap-header.cc ns-3.33/src/network/utils/radiotap-header.cc
--- ns-3.32/src/network/utils/radiotap-header.cc	2020-10-06 15:35:43.000000000 -0700
+++ ns-3.33/src/network/utils/radiotap-header.cc	2021-01-09 10:19:22.000000000 -0800
@@ -54,7 +54,17 @@
     m_heData1 (0),
     m_heData2 (0),
     m_heData3 (0),
-    m_heData5 (0)
+    m_heData4 (0),
+    m_heData5 (0),
+    m_heData6 (0),
+    m_heMuPad (0),
+    m_heMuFlags1 (0),
+    m_heMuFlags2 (0),
+    m_heMuOtherUserPad (0),
+    m_heMuPerUser1 (0),
+    m_heMuPerUser2 (0),
+    m_heMuPerUserPosition (0),
+    m_heMuPerUserKnown (0)
 {
   NS_LOG_FUNCTION (this);
 }
@@ -96,6 +106,7 @@
   //
   // Time Synchronization Function Timer (when the first bit of the MPDU
   // arrived at the MAC)
+  // Reference: https://www.radiotap.org/fields/TSFT.html
   //
   if (m_present & RADIOTAP_TSFT) // bit 0
     {
@@ -104,6 +115,7 @@
 
   //
   // Properties of transmitted and received frames.
+  // Reference: https://www.radiotap.org/fields/Flags.html
   //
   if (m_present & RADIOTAP_FLAGS) // bit 1
     {
@@ -112,6 +124,7 @@
 
   //
   // TX/RX data rate in units of 500 kbps
+  // Reference: https://www.radiotap.org/fields/Rate.html
   //
   if (m_present & RADIOTAP_RATE) // bit 2
     {
@@ -120,6 +133,7 @@
 
   //
   // Tx/Rx frequency in MHz, followed by flags.
+  // Reference: https://www.radiotap.org/fields/Channel.html
   //
   if (m_present & RADIOTAP_CHANNEL) // bit 3
     {
@@ -131,6 +145,7 @@
   //
   // The hop set and pattern for frequency-hopping radios.  We don't need it but
   // still need to account for it.
+  // Reference: https://www.radiotap.org/fields/FHSS.html
   //
   if (m_present & RADIOTAP_FHSS) // bit 4
     {
@@ -140,6 +155,7 @@
   //
   // RF signal power at the antenna, decibel difference from an arbitrary, fixed
   // reference.
+  // Reference: https://www.radiotap.org/fields/Antenna%20signal.html
   //
   if (m_present & RADIOTAP_DBM_ANTSIGNAL) // bit 5
     {
@@ -149,6 +165,7 @@
   //
   // RF noise power at the antenna, decibel difference from an arbitrary, fixed
   // reference.
+  // Reference: https://www.radiotap.org/fields/Antenna%20noise.html
   //
   if (m_present & RADIOTAP_DBM_ANTNOISE) // bit 6
     {
@@ -157,6 +174,7 @@
 
   //
   // Quality of Barker code lock.
+  // Reference: https://www.radiotap.org/fields/Lock%20quality.html
   //
   if (m_present & RADIOTAP_LOCK_QUALITY) // bit 7
     {
@@ -166,6 +184,7 @@
   //
   // Transmit power expressed as unitless distance from max power
   // set at factory calibration (0 is max power).
+  // Reference: https://www.radiotap.org/fields/TX%20attenuation.html
   //
   if (m_present & RADIOTAP_TX_ATTENUATION) // bit 8
     {
@@ -175,6 +194,7 @@
   //
   // Transmit power expressed as decibel distance from max power
   // set at factory calibration (0 is max power).
+  // Reference: https://www.radiotap.org/fields/dB%20TX%20attenuation.html
   //
   if (m_present & RADIOTAP_DB_TX_ATTENUATION) // bit 9
     {
@@ -184,6 +204,7 @@
   //
   // Transmit power expressed as dBm (decibels from a 1 milliwatt reference).
   // This is the absolute power level measured at the antenna port.
+  // Reference: https://www.radiotap.org/fields/dBm%20TX%20power.html
   //
   if (m_present & RADIOTAP_DBM_TX_POWER) // bit 10
     {
@@ -193,6 +214,7 @@
   //
   // Unitless indication of the Rx/Tx antenna for this packet.
   // The first antenna is antenna 0.
+  // Reference: https://www.radiotap.org/fields/Antenna.html
   //
   if (m_present & RADIOTAP_ANTENNA) // bit 11
     {
@@ -201,6 +223,7 @@
 
   //
   // RF signal power at the antenna (decibel difference from an arbitrary fixed reference).
+  // Reference: https://www.radiotap.org/fields/dB%20antenna%20signal.html
   //
   if (m_present & RADIOTAP_DB_ANTSIGNAL) // bit 12
     {
@@ -209,6 +232,7 @@
 
   //
   // RF noise power at the antenna (decibel difference from an arbitrary fixed reference).
+  // Reference: https://www.radiotap.org/fields/dB%20antenna%20noise.html
   //
   if (m_present & RADIOTAP_DB_ANTNOISE) // bit 13
     {
@@ -217,6 +241,7 @@
 
   //
   // Properties of received frames.
+  // Reference: https://www.radiotap.org/fields/RX%20flags.html
   //
   if (m_present & RADIOTAP_RX_FLAGS) // bit 14
     {
@@ -225,6 +250,7 @@
 
   //
   // MCS field.
+  // Reference: https://www.radiotap.org/fields/MCS.html
   //
   if (m_present & RADIOTAP_MCS) // bit 19
     {
@@ -235,6 +261,7 @@
 
   //
   // A-MPDU Status, information about the received or transmitted A-MPDU.
+  // Reference: https://www.radiotap.org/fields/A-MPDU%20status.html
   //
   if (m_present & RADIOTAP_AMPDU_STATUS) // bit 20
     {
@@ -247,6 +274,7 @@
 
   //
   // Information about the received or transmitted VHT frame.
+  // Reference: https://www.radiotap.org/fields/VHT.html
   //
   if (m_present & RADIOTAP_VHT) // bit 21
     {
@@ -265,6 +293,7 @@
 
   //
   // HE field.
+  // Reference: https://www.radiotap.org/fields/HE.html
   //
   if (m_present & RADIOTAP_HE) // bit 23
     {
@@ -272,9 +301,41 @@
       start.WriteU16 (m_heData1);
       start.WriteU16 (m_heData2);
       start.WriteU16 (m_heData3);
-      start.WriteU16 (0); //HE data4 field
+      start.WriteU16 (m_heData4);
       start.WriteU16 (m_heData5);
-      start.WriteU16 (0); //HE data6 field
+      start.WriteU16 (m_heData6);
+    }
+
+  //
+  // HE MU field.
+  // Reference: https://www.radiotap.org/fields/HE-MU.html
+  //
+  if (m_present & RADIOTAP_HE_MU) // bit 24
+    {
+      start.WriteU8 (0, m_heMuPad);
+      start.WriteU16 (m_heMuFlags1);
+      start.WriteU16 (m_heMuFlags2);
+      start.WriteU8 (0);
+      start.WriteU8 (0);
+      start.WriteU8 (0);
+      start.WriteU8 (0);
+      start.WriteU8 (0);
+      start.WriteU8 (0);
+      start.WriteU8 (0);
+      start.WriteU8 (0);
+    }
+
+  //
+  // HE MU other user field.
+  // Reference: https://www.radiotap.org/fields/HE-MU-other-user.html
+  //
+  if (m_present & RADIOTAP_HE_MU_OTHER_USER) // bit 25
+    {
+      start.WriteU8 (0, m_heMuOtherUserPad);
+      start.WriteU16 (m_heMuPerUser1);
+      start.WriteU16 (m_heMuPerUser2);
+      start.WriteU8 (m_heMuPerUserPosition);
+      start.WriteU8 (m_heMuPerUserKnown);
     }
 }
 
@@ -294,6 +355,7 @@
 
   //
   // Time Synchronization Function Timer (when the first bit of the MPDU arrived at the MAC)
+  // Reference: https://www.radiotap.org/fields/TSFT.html
   //
   if (m_present & RADIOTAP_TSFT) // bit 0
     {
@@ -303,6 +365,7 @@
 
   //
   // Properties of transmitted and received frames.
+  // Reference: https://www.radiotap.org/fields/Flags.html
   //
   if (m_present & RADIOTAP_FLAGS) // bit 1
     {
@@ -312,6 +375,7 @@
 
   //
   // TX/RX data rate in units of 500 kbps
+  // Reference: https://www.radiotap.org/fields/Rate.html
   //
   if (m_present & RADIOTAP_RATE) // bit 2
     {
@@ -321,6 +385,7 @@
 
   //
   // Tx/Rx frequency in MHz, followed by flags.
+  // Reference: https://www.radiotap.org/fields/Channel.html
   //
   if (m_present & RADIOTAP_CHANNEL) // bit 3
     {
@@ -334,6 +399,7 @@
   //
   // The hop set and pattern for frequency-hopping radios.  We don't need it but
   // still need to account for it.
+  // Reference: https://www.radiotap.org/fields/FHSS.html
   //
   if (m_present & RADIOTAP_FHSS) // bit 4
     {
@@ -345,6 +411,7 @@
   //
   // RF signal power at the antenna, decibel difference from an arbitrary, fixed
   // reference.
+  // Reference: https://www.radiotap.org/fields/Antenna%20signal.html
   //
   if (m_present & RADIOTAP_DBM_ANTSIGNAL) // bit 5
     {
@@ -355,6 +422,7 @@
   //
   // RF noise power at the antenna, decibel difference from an arbitrary, fixed
   // reference.
+  // Reference: https://www.radiotap.org/fields/Antenna%20noise.html
   //
   if (m_present & RADIOTAP_DBM_ANTNOISE) // bit 6
     {
@@ -364,6 +432,7 @@
 
   //
   // Quality of Barker code lock.
+  // Reference: https://www.radiotap.org/fields/Lock%20quality.html
   //
   if (m_present & RADIOTAP_LOCK_QUALITY) // bit 7
     {
@@ -375,6 +444,7 @@
   //
   // Transmit power expressed as unitless distance from max power
   // set at factory calibration (0 is max power).
+  // Reference: https://www.radiotap.org/fields/TX%20attenuation.html
   //
   if (m_present & RADIOTAP_TX_ATTENUATION) // bit 8
     {
@@ -386,6 +456,7 @@
   //
   // Transmit power expressed as decibel distance from max power
   // set at factory calibration (0 is max power).
+  // Reference: https://www.radiotap.org/fields/dB%20TX%20attenuation.html
   //
   if (m_present & RADIOTAP_DB_TX_ATTENUATION) // bit 9
     {
@@ -397,6 +468,7 @@
   //
   // Transmit power expressed as dBm (decibels from a 1 milliwatt reference).
   // This is the absolute power level measured at the antenna port.
+  // Reference: https://www.radiotap.org/fields/dBm%20TX%20power.html
   //
   if (m_present & RADIOTAP_DBM_TX_POWER) // bit 10
     {
@@ -408,6 +480,7 @@
   //
   // Unitless indication of the Rx/Tx antenna for this packet.
   // The first antenna is antenna 0.
+  // Reference: https://www.radiotap.org/fields/Antenna.html
   //
   if (m_present & RADIOTAP_ANTENNA) // bit 11
     {
@@ -418,6 +491,7 @@
 
   //
   // RF signal power at the antenna (decibel difference from an arbitrary fixed reference).
+  // Reference: https://www.radiotap.org/fields/dB%20antenna%20signal.html
   //
   if (m_present & RADIOTAP_DB_ANTSIGNAL) // bit 12
     {
@@ -428,6 +502,7 @@
 
   //
   // RF noise power at the antenna (decibel difference from an arbitrary fixed reference).
+  // Reference: https://www.radiotap.org/fields/dB%20antenna%20noise.html
   //
   if (m_present & RADIOTAP_DB_ANTNOISE) // bit 13
     {
@@ -438,6 +513,7 @@
 
   //
   // Properties of received frames.
+  // Reference: https://www.radiotap.org/fields/RX%20flags.html
   //
   if (m_present & RADIOTAP_RX_FLAGS) // bit 14
     {
@@ -448,6 +524,7 @@
 
   //
   // MCS field.
+  // Reference: https://www.radiotap.org/fields/MCS.html
   //
   if (m_present & RADIOTAP_MCS) // bit 19
     {
@@ -459,6 +536,7 @@
 
   //
   // A-MPDU Status, information about the received or transmitted A-MPDU.
+  // Reference: https://www.radiotap.org/fields/A-MPDU%20status.html
   //
   if (m_present & RADIOTAP_AMPDU_STATUS) // bit 20
     {
@@ -473,6 +551,7 @@
 
   //
   // Information about the received or transmitted VHT frame.
+  // Reference: https://www.radiotap.org/fields/VHT.html
   //
   if (m_present & RADIOTAP_VHT) // bit 21
     {
@@ -493,6 +572,7 @@
 
   //
   // HE field.
+  // Reference: https://www.radiotap.org/fields/HE.html
   //
   if (m_present & RADIOTAP_HE) // bit 23
     {
@@ -501,12 +581,46 @@
       m_heData1 = start.ReadU16 ();
       m_heData2 = start.ReadU16 ();
       m_heData3 = start.ReadU16 ();
-      start.ReadU16 (); //HE data4 field
+      m_heData4 = start.ReadU16 ();
       m_heData5 = start.ReadU16 ();
-      start.ReadU16 (); //HE data6 field
+      m_heData6 = start.ReadU16 ();
       bytesRead += (12 + m_hePad);
     }
 
+  //
+  // HE MU field.
+  // Reference: https://www.radiotap.org/fields/HE-MU.html
+  //
+  if (m_present & RADIOTAP_HE_MU) // bit 24
+    {
+      m_heMuPad = ((2 - bytesRead % 2) % 2);
+      m_heMuFlags1 = start.ReadU16 ();
+      m_heMuFlags2 = start.ReadU16 ();
+      start.ReadU8 ();
+      start.ReadU8 ();
+      start.ReadU8 ();
+      start.ReadU8 ();
+      start.ReadU8 ();
+      start.ReadU8 ();
+      start.ReadU8 ();
+      start.ReadU8 ();
+      bytesRead += (12 + m_heMuPad);
+    }
+
+  //
+  // HE MU other user field.
+  // Reference: https://www.radiotap.org/fields/HE-MU-other-user.html
+  //
+  if (m_present & RADIOTAP_HE_MU_OTHER_USER) // bit 25
+    {
+      m_heMuOtherUserPad = ((2 - bytesRead % 2) % 2);
+      m_heMuPerUser1 = start.ReadU16 ();
+      m_heMuPerUser2 = start.ReadU16 ();
+      m_heMuPerUserPosition = start.ReadU8 ();
+      m_heMuPerUserKnown = start.ReadU8 ();
+      bytesRead += (6 + m_heMuOtherUserPad);
+    }
+
   NS_ASSERT_MSG (m_length == bytesRead, "RadiotapHeader::Deserialize(): expected and actual lengths inconsistent");
   return bytesRead;
 }
@@ -539,7 +653,15 @@
      << " heData1=" << m_heData1
      << " heData2=" << m_heData2
      << " heData3=" << m_heData3
-     << " heData5=" << m_heData5;
+     << " heData4=" << m_heData4
+     << " heData5=" << m_heData5
+     << " heData6=" << m_heData6
+     << " heMuFlags1=" << m_heMuFlags1
+     << " heMuFlags2=" << m_heMuFlags2
+     << " heMuPerUser1=" << m_heMuPerUser1
+     << " heMuPerUser2=" << m_heMuPerUser2
+     << " heMuPerUserPosition=" << +m_heMuPerUserPosition
+     << " heMuPerUserKnown=" << +m_heMuPerUserKnown;
 }
 
 void
@@ -714,13 +836,15 @@
 }
 
 void
-RadiotapHeader::SetHeFields (uint16_t data1, uint16_t data2, uint16_t data3, uint16_t data5)
+RadiotapHeader::SetHeFields (uint16_t data1, uint16_t data2, uint16_t data3, uint16_t data4, uint16_t data5, uint16_t data6)
 {
-  NS_LOG_FUNCTION (this << data1 << data2 << data3 << data5);
+  NS_LOG_FUNCTION (this << data1 << data2 << data3 << data4 << data5 << data6);
   m_heData1 = data1;
   m_heData2 = data2;
   m_heData3 = data3;
+  m_heData4 = data4;
   m_heData5 = data5;
+  m_heData6 = data6;
   if (!(m_present & RADIOTAP_HE))
     {
       m_hePad = ((2 - m_length % 2) % 2);
@@ -729,6 +853,40 @@
     }
 
   NS_LOG_LOGIC (this << " m_length=" << m_length << " m_present=0x" << std::hex << m_present << std::dec);
+}
+
+void
+RadiotapHeader::SetHeMuFields (uint16_t flags1, uint16_t flags2, const std::array<uint8_t, 4> &/*ruChannel1*/, const std::array<uint8_t, 4> &/*ruChannel2*/)
+{
+  NS_LOG_FUNCTION (this << flags1 << flags2);
+  m_heMuFlags1 = flags1;
+  m_heMuFlags2 = flags2;
+  if (!(m_present & RADIOTAP_HE_MU))
+    {
+      m_heMuPad = ((2 - m_length % 2) % 2);
+      m_present |= RADIOTAP_HE_MU;
+      m_length += (12 + m_heMuPad);
+    }
+
+  NS_LOG_LOGIC (this << " m_length=" << m_length << " m_present=0x" << std::hex << m_present << std::dec);
+}
+
+void
+RadiotapHeader::SetHeMuPerUserFields (uint16_t per_user_1, uint16_t per_user_2, uint8_t perUserPosition, uint8_t perUserKnown)
+{
+  NS_LOG_FUNCTION (this << per_user_1 << per_user_2 << +perUserPosition << +perUserKnown);
+  m_heMuPerUser1 = per_user_1;
+  m_heMuPerUser2 = per_user_2;
+  m_heMuPerUserPosition = perUserPosition;
+  m_heMuPerUserKnown = perUserKnown;
+  if (!(m_present & RADIOTAP_HE_MU_OTHER_USER))
+    {
+      m_heMuOtherUserPad = ((2 - m_length % 2) % 2);
+      m_present |= RADIOTAP_HE_MU_OTHER_USER;
+      m_length += (6 + m_heMuOtherUserPad);
+    }
+
+  NS_LOG_LOGIC (this << " m_length=" << m_length << " m_present=0x" << std::hex << m_present << std::dec);
 }
 
 } // namespace ns3
